"{ Package: 'stx:libview' }"

WinWorkstation subclass:#WinPrinter
	instanceVariableNames:'printerInfo'
	classVariableNames:''
	poolDictionaries:''
	category:'Interface-Printing'
!

!WinPrinter primitiveDefinitions!
%{
#define TRACE_ALL_EVENTS      /* */

#define COUNT_RESOURCES       /* */
#define COUNT_BMP_RESOURCES   /* */
#define DEBUG_DELETEOBJECT    /* */
#define DEBUG_DC_REUSE        /* */
#define xxDEBUG_COLORIZE_WM_PAINT_RECTS1
#define xxDEBUG_COLORIZE_WM_PAINT_RECTS2
#define LOCK_DEBUG

#define ADJUSTWINDOW
#define ALWAYSTRUECOLOR
#define WIN32THREADS

/* #define DEBUGMASK            /* */
#define SET_FOCUS_IN_WINTHREAD
#define SET_CURSOR_IN_WINTHREAD
#define DELAY_ENTER_LEAVE_WHILE_IN_SIZE_MOVE /* */
#define xxBEEP_IN_WINTHREAD    /* */
#define xxKEEP_STD_CURSORS     /* not useful - those are allocated only once, in any case */
#define xxHANDLE_VIEWGRAVITY   /* not yet working */
#define COMPRESS_WINDOWPOSCHANGED

#define USE_DRAW_MUTEX
#define xxLATE_GENERATE_EXPOSE              /* get update region from stx thread */
#define xxNO_CLEAR_FOR_WM_PAINT           /* do not fill exposed areas with bgColor */
#define xxLATE_CLEAR_FOR_WM_PAINT         /* fill exposed areas with bgColor in ST/X thread (instead of in event-thread) */
                                        /* seems to be needed to avoid DC conflicts */

#if 0 /* DOES NOT WORK */
#define CACHE_LAST_DC                   /* remember last DC in gcData */
#define CACHE_LAST_PEN                  /* remember last pen in gcData */
#define CACHE_LAST_BRUSH                /* remember last brush in gcData */
#define CACHE_LAST_WM_PAINT_BRUSH       /* remember last viewBackground brush */
#define CACHE_LAST_WM_PAINT_DC          /* remember last viewBackground paints dc */
#define CACHE_LAST_TMP_FONT             /* */

#endif


#define CACHE_PEN
#define CACHE_BRUSH

#ifndef PRE_07_APR_04
# define CACHE_LAST_DC
#endif


#ifdef CACHE_PEN
# define NUM_PEN_CACHED_W95   8          /* that many solid pens are globally remembered */
# define NUM_PEN_CACHED_NT    16         /* that many solid pens are globally remembered */
# define MAX_NUM_PEN_CACHED   32         /* upper limit */
#else
# define NUM_PEN_CACHED_W95   0
# define NUM_PEN_CACHED_NT    0
# define MAX_NUM_PEN_CACHED   0
#endif

#ifdef CACHE_BRUSH
# define NUM_BRUSH_CACHED_W95 8          /* that many brushes are globally remembered */
# define NUM_BRUSH_CACHED_NT  16         /* that many brushes are globally remembered */
# define MAX_NUM_BRUSH_CACHED 32         /* upper limit */
#else
# define NUM_BRUSH_CACHED_W95 0
# define NUM_BRUSH_CACHED_NT  0
# define MAX_NUM_BRUSH_CACHED 0
#endif

#if defined(NO_CLEAR_FOR_WM_PAINT)
# define WM_PAINT_CLEAR_EARLY       0
# define WM_PAINT_CLEAR_LATE        0
#else
# if defined(LATE_CLEAR_FOR_WM_PAINT)
#  define WM_PAINT_CLEAR_EARLY       0
#  define WM_PAINT_CLEAR_LATE        1
# else
#  define WM_PAINT_CLEAR_EARLY       1
#  define WM_PAINT_CLEAR_LATE        0
# endif
#endif

#undef INT
#define INT WIN_INT
#undef Array
#define Array WIN_Array
#undef Number
#define Number WIN_Number
#undef Method
#define Method WIN_Method
#undef Point
#define Point WIN_Point
#undef Rectangle
/* #define Rectangle WIN_Rectangle */
#undef True
#define True WIN_True
#undef False
#define False WIN_False
#undef Block
#define Block WIN_Block
#undef Context
#define Context WIN_Context
#undef Date
#define Date WIN_Date
#undef Time
#define Time WIN_Time
#undef Delay
#define Delay WIN_Delay
#undef Signal
#define Signal WIN_Signal
#undef Set
#define Set WIN_Set

#include <stdio.h>
#include <errno.h>
/* #include <malloc.h> */
/* #include <math.h> */
/* #include <string.h> */

/*#include <stdarg.h>   */

#ifdef __BORLANDC__
# define NOATOM
# define NOGDICAPMASKS
# define NOMETAFILE
# define NOMINMAX
# define NOOPENFILE
# define NOSOUND
# define NOWH
# define NOCOMM
# define NOKANJI
# define NOCRYPT
# define NOMCX
# define WIN32_LEAN_AND_MEAN
# include <windows.h>
# include <shellapi.h>
# include <sys\timeb.h>
# include <dir.h>
#else
# define _USERENTRY /**/
# define NOATOM
# define NOGDICAPMASKS
# define NOMETAFILE
# define NOMINMAX
# define NOOPENFILE
# define NOSOUND
# define NOWH
# define NOCOMM
# define NOKANJI
# define NOCRYPT
# define NOMCX
# define WIN32_LEAN_AND_MEAN
# include <windows.h>
# include <sys\timeb.h>
#endif
#include <commdlg.h>

#include <process.h>

#ifdef __DEF_Array
# undef Array
# define Array __DEF_Array
#endif
#ifdef __DEF_Number
# undef Number
# define Number __DEF_Number
#endif
#ifdef __DEF_Method
# undef Method
# define Method __DEF_Method
#endif
#ifdef __DEF_Point
# undef Point
# define Point __DEF_Point
#endif
#ifdef __DEF_Rectangle
# undef Rectangle
# define Rectangle __DEF_Rectangle
#else
# undef Rectangle
#endif
#ifdef __DEF_Block
# undef Block
# define Block __DEF_Block
#endif
#ifdef __DEF_Context
# undef Context
# define Context __DEF_Context
#endif
#ifdef __DEF_Date
# undef Date
# define Date __DEF_Date
#endif
#ifdef __DEF_Time
# undef Time
# define Time __DEF_Time
#endif
# ifdef __DEF_Set
#  undef Set
#  define Set __DEF_Set
# endif
# ifdef __DEF_Signal
#  undef Signal
#  define Signal __DEF_Signal
# endif
# ifdef __DEF_Delay
#  undef Delay
#  define Delay __DEF_Delay
# endif
#undef INT

#define INT int

/*
 * some defines - tired of typing ...
 */
#define _HANDLEVal(o)        (HANDLE)(__MKCP(o))
#define _HBITMAPVAL(o)       (HBITMAP)(__MKCP(o))
#define _HWNDVal(o)          (HWND)(__MKCP(o))
#define _HPALETTEVal(o)      (HPALETTE)(__MKCP(o))
#define _HCURSORVal(o)       (HCURSOR)(__MKCP(o))
#define _HGDIOBJVal(o)       (HGDIOBJ)(__MKCP(o))
#define _LOGPALETTEVal(o)    (LOGPALETTE *)(__MKCP(o))
#define _COLORREFVal(o)      (COLORREF)(__MKCP(o))

#define _GCDATA(o)           ((struct gcData *)(__MKCP(o)))

#define WIDECHAR unsigned short

#ifdef LATER
  /* for multi-WIN display support, we need this as an instance var (as below)
   * however, there are many more places, where a single static datum is
   * used currently - therefore dont care for this - at least now.
   */
# define __rootDC             (HDC)(__MKCP(__INST(rootDC)))
#endif

#define ISCONNECTED         1

struct gcData {
    union {
        HDC         __hDC;
        struct gcData *__nextFree;
    } u;
    HWND        hWnd;
    HBITMAP     hBitmap;
    HBITMAP     save_hBitmap;
    HBITMAP     hMask;
    short       clipX;
    short       clipY;
    short       clipW;
    short       clipH;
    char        clipping;
    char        clipByChildren;
    char        bkMode;
    char        bitmapColorBitCount;
    short       maskOrgX;
    short       maskOrgY;
    short       lineWidth;
    short       fontAscent;
    int         lStyle;   /* is lineStyle | joinStyle | capStyle */
    int         rop2;
    int         bitbltrop2;
    COLORREF    fgColor;
    COLORREF    bgColor;
    HFONT       hFont;
    HFONT       save_hFont;
    HPEN        hPen;
    HPEN        save_hPen;
    HBRUSH      hBrush;
    HBRUSH      save_hBrush;
};
#define _hDC u.__hDC

/*
 * some synthetic values
 */
/*****************************************************************
 * EVENT DEFINITIONS
 *****************************************************************/

/* Input Event Masks. Used as event-mask window attribute and as arguments
   to Grab requests.  Not to be confused with event names.  */

#define NoEventMask                     0L
#define KeyPressMask                    (1L<<0)
#define KeyReleaseMask                  (1L<<1)
#define ButtonPressMask                 (1L<<2)
#define ButtonReleaseMask               (1L<<3)
#define EnterWindowMask                 (1L<<4)
#define LeaveWindowMask                 (1L<<5)
#define PointerMotionMask               (1L<<6)
#define PointerMotionHintMask           (1L<<7)
#define Button1MotionMask               (1L<<8)
#define Button2MotionMask               (1L<<9)
#define Button3MotionMask               (1L<<10)
#if 0
# define Button4MotionMask               (1L<<11)
# define Button5MotionMask               (1L<<12)
#endif
#define ButtonMotionMask                (1L<<13)
#define KeymapStateMask                 (1L<<14)
#define ExposureMask                    (1L<<15)
#define VisibilityChangeMask            (1L<<16)
#define StructureNotifyMask             (1L<<17)
#define ResizeRedirectMask              (1L<<18)
#define SubstructureNotifyMask          (1L<<19)
#define SubstructureRedirectMask        (1L<<20)
#define FocusChangeMask                 (1L<<21)
#define PropertyChangeMask              (1L<<22)
#define ColormapChangeMask              (1L<<23)
#define OwnerGrabButtonMask             (1L<<24)

/* Event names.  Used in "type" field in XEvent structures.  Not to be
confused with event masks above.  They start from 2 because 0 and 1
are reserved in the protocol for errors and replies. */

#define KeyPress                2
#define KeyRelease              3
#define ButtonPress             4
#define ButtonRelease           5
#define MotionNotify            6
#define EnterNotify             7
#define LeaveNotify             8
#define FocusIn                 9
#define FocusOut                10
#define KeymapNotify            11
#define Expose                  12
#define GraphicsExpose          13
#define NoExpose                14
#define VisibilityNotify        15
#define CreateNotify            16
#define DestroyNotify           17
#define UnmapNotify             18
#define MapNotify               19
#define MapRequest              20
#define ReparentNotify          21
#define ConfigureNotify         22
#define ConfigureRequest        23
#define GravityNotify           24
#define ResizeRequest           25
#define CirculateNotify         26
#define CirculateRequest        27
#define PropertyNotify          28
#define SelectionClear          29
#define SelectionRequest        30
#define SelectionNotify         31
#define ColormapNotify          32
#define ClientMessage           33
#define MappingNotify           34
#define LASTEvent               35      /* must be bigger than any event # */

/* Key masks. Used as modifiers to GrabButton and GrabKey, results of QueryPointer,
   state in various key-, mouse-, and button-related events. */

#define ShiftMask               (1<<0)
#define LockMask                (1<<1)
#define ControlMask             (1<<2)
#define Mod1Mask                (1<<3)
#define Mod2Mask                (1<<4)
#define Mod3Mask                (1<<5)
#define Mod4Mask                (1<<6)
#define Mod5Mask                (1<<7)

/* modifier names.  Used to build a SetModifierMapping request or
   to read a GetModifierMapping request.  These correspond to the
   masks defined above. */
#define ShiftMapIndex           0
#define LockMapIndex            1
#define ControlMapIndex         2
#define Mod1MapIndex            3
#define Mod2MapIndex            4
#define Mod3MapIndex            5
#define Mod4MapIndex            6
#define Mod5MapIndex            7


/* button masks.  Used in same manner as Key masks above. Not to be confused
   with button names below. */

#define Button1Mask            Button1MotionMask
#define Button2Mask            Button2MotionMask
#define Button3Mask            Button3MotionMask
#if 0
# define Button4Mask            Button4MotionMask
# define Button5Mask            Button5MotionMask
#endif
#define AnyButtonMask           (Button1Mask|Button2Mask|Button3Mask)

#if 0
# define AnyModifier             (1<<15)  /* used in GrabButton, GrabKey */
#endif

/* button names. Used as arguments to GrabButton and as detail in ButtonPress
   and ButtonRelease events.  Not to be confused with button masks above.
   Note that 0 is already defined above as "AnyButton".  */

#define Button1                 1
#define Button2                 2
#define Button3                 3
#if 0
# define Button4                 4
# define Button5                 5
#endif

#define CAPTURE_NONE     0
#define CAPTURE_IMPLICIT 7
#define CAPTURE_EXPLICIT 8

#define BK_UNDEF         0
#define BK_TRANSPARENT   1
#define BK_OPAQUE        2

#define GRAVITY_NONE        0
#define GRAVITY_S           1
#define GRAVITY_SW          2
#define GRAVITY_SE          3
#define GRAVITY_N           4
#define GRAVITY_NW          5
#define GRAVITY_NE          6
#define GRAVITY_E           7
#define GRAVITY_W           8

/*#define ControlMask            8
#define ShiftMask              16*/
#define LeftAltMask            Mod1Mask
#define RightAltMask           Mod2Mask
#define TRANSLATED_KEY         Mod5Mask

#define WIN32PADDING 32

/*
 * synthetic events
 */
#define __WM_MOUSEENTER        0x10001
#define __WM_MOUSELEAVE        0x10002
#define __WM_GEXPOSE           0x10003
#define __WM_NOGEXPOSE         0x10004
#define __WM_ICONIFIED         0x10005
#define __WM_PAINT             0x10006

static int AltMask = RightAltMask;
static int MetaMask = LeftAltMask;

#define WhitePixel     RGB(0xFF, 0xFF, 0xFF)
#define BlackPixel     RGB(0, 0, 0)

/* #undef DEBUG /* */

#ifdef DEBUG
# define PRINTF(x)              { printf x;}
# define CPRINTF(x)             { if (__debug__ > 1) printf x;}
# define RESPRINTF(x)           /*{ if (__debug__) printf x;}*/
# define RES1PRINTF(x)          /*{ if (__debug__) printf x;}*/
# define RES_BMP_PRINTF(x)      /*{ if (__debug__) printf x;}*/
# define TH_DPRINTF(x)          /*{ if (__debug__) printf x;}*/
# define DPRINTF(x)             { if (__debug__) printf x;}
# define NDPRINTF(x)            { if (__debugNative__) printf x;}
# define NDPRINTF2(x)           { if (__debugNative__ > 1) printf x;}
# define DDPRINTF(x)            { if (__debug__ > 1) printf x;}
# define BMDPRINTF(x)           { if (__debug__ > 1) printf x;}
# define EVENT_PRINTF(x)        { if (__debug__) printf x;}
# define EVENT_PRINTF2(x)       { if (__debug__ > 1) printf x;}
# define EVENT_PRINTF3(x)       /* */
# define DPRINTFIF(flag, x)                 { if (flag && __debug__) printf x;}
# define EVENT_PRINTFIF(flag, x)            { if (flag && __debug__) printf x;}
# define UNHANDLED_EVENT_PRINTF(x)          { if (__debug__) { printf("unhandled: "); printf x; } }
# define UNHANDLED_EVENT_PRINTFIF(flag, x)  { if (flag && __debug__) { printf("unhandled: "); printf x; } }
#else
# define PRINTF(x)              /* */
# define CPRINTF(x)             /* */
# define RES_BMP_PRINTF(x)      /* */
# define RESPRINTF(x)           /* */
# define RES1PRINTF(x)          /* */
# define TH_DPRINTF(x)          /* */
# define DPRINTF(x)             /* */
# define NDPRINTF(x)            /* */
# define NDPRINTF2(x)           /* */
# define DDPRINTF(x)            /* */
# define BMDPRINTF(x)           /* */
# define EVENT_PRINTF(x)        /* */
# define EVENT_PRINTF2(x)       /* */
# define EVENT_PRINTF3(x)       /* */
# define DPRINTFIF(flag, x)             /* */
# define EVENT_PRINTFIF(flag, x)        /* */
# define UNHANDLED_EVENT_PRINTF(x)      /* */
# define UNHANDLED_EVENT_PRINTFIF(x)    /* */
#endif

/* # define EVENT_PRINTF(x)        { printf x;} */

#define INFOPRINT(__x__)                 \
    if (@global(InfoPrinting) == true) { \
        fprintf __x__;           \
    }

#define DEBUGPRINT(__x__)                 \
    if (@global(InfoPrinting) == true) { \
        fprintf __x__;           \
    }

#define BR_SOLID       0
#define BR_PATTERN     1

#define LINE_SOLID     0
#define LINE_DASH      1
#define LINE_DDASH     2

#ifdef KEEP_STD_CURSORS
# define _C_ARROW       1
# define _C_CROSS       2
# define _C_IBEAM       3
# define _C_ICON        4
# define _C_NO          5
# define _C_SIZE        6
# define _C_SIZEALL     7
# define _C_SIZENESW    8
# define _C_SIZENS      9
# define _C_SIZENWSE    10
# define _C_UPARROW     11
# define _C_WAIT        12

 static HCURSOR H_C_ARROW = (HCURSOR)0;
 static HCURSOR H_C_CROSS = (HCURSOR)0;
 static HCURSOR H_C_IBEAM = (HCURSOR)0;
 static HCURSOR H_C_ICON = (HCURSOR)0;
 static HCURSOR H_C_NO = (HCURSOR)0;
 static HCURSOR H_C_SIZE = (HCURSOR)0;
 static HCURSOR H_C_SIZEALL = (HCURSOR)0;
 static HCURSOR H_C_SIZENESW = (HCURSOR)0;
 static HCURSOR H_C_SIZENS = (HCURSOR)0;
 static HCURSOR H_C_SIZENWSE = (HCURSOR)0;
 static HCURSOR H_C_UPARROW = (HCURSOR)0;
 static HCURSOR H_C_WAIT = (HCURSOR)0;
 static HCURSOR H_C_APPSTARTING = (HCURSOR)0;
#endif /* KEEP_STD_CURSORS */

#ifdef EXIT_WITH_3_CTRL_Cs
static int ctrl_c_count = 0;            /* CTRL-C count */
#endif
#ifdef RELEASE_CAPTURE_WITH_3_ESCAPEs
static int escape_count = 0;            /* ESCAPE count */
#endif

static int evRootX, evRootY;
static int multiClickCount = 0;
static UINT lastMSGTime;
static UINT lastMouseWheelTime = 0;
static int lastClickX, lastClickY;
static int lastMotionX = -9999, lastMotionY = -9999;
static HWND lastMotionWnd = 0;
static int deltaDoubleClickX = -999;
static int deltaDoubleClickY = -999;
static UINT nextMultiClickTime;
static int inSizeMove = 0;
static int inSize = 0;
static int inMove = 0;
static HWND needDelayedMouseLeaveWindow = 0;
static HWND needDelayedMouseEnterWindow = 0;
static int delayedMouseEnterX, delayedMouseEnterY;
static int destroyWin;
static HDC   __tmpDC;
#ifdef CACHE_LAST_TMP_FONT
static HFONT __tmpDC_hfont = 0, __tmpDC_prev_hfont = 0;
#endif
static int __isWinNT = 0;
static int __isWinNT_NEW_BEHAVIOUR = 0;

static int __isWinXP = 0;
static int __logPixelSY;

static int NUM_PEN_CACHED   = NUM_PEN_CACHED_W95;       /* that many solid pens are globally remembered */
static int NUM_BRUSH_CACHED = NUM_BRUSH_CACHED_W95;     /* that many brushes are globally remembered */

#ifdef CACHE_LAST_DC
static struct gcData *lastGcData = 0;
static int            lastGcOwnerThreadID = 0;
static HWND           lastGcHWIN;
static HBITMAP        lastGcHBITMAP;
#endif

#ifndef __rootDC
 static HDC __rootDC;
#endif

#ifdef CACHE_PEN
struct __penCache {
    HPEN            pen;
    unsigned int    clr;
} __penCache[MAX_NUM_PEN_CACHED];
#endif

#ifdef CACHE_BRUSH
struct __brushCache {
    HBRUSH          brush;
    unsigned int    clr;
} __brushCache[MAX_NUM_BRUSH_CACHED];
#endif

/*
 * globally cached - never released
 */
static HPEN __blackPen = 0;
static HPEN __whitePen = 0;
static HPEN __nullPen = 0;
static HBRUSH __blackBrush = 0;
static HBRUSH __whiteBrush = 0;

static HPEN __bgPen = 0;
static int __bgPenColor = 0;

#define WM_THREAD_CREATEWINDOW   WM_USER + 0x101
#define WM_THREAD_DESTROYWINDOW  WM_USER + 0x102
#define WM_THREAD_SETFOCUS       WM_USER + 0x103
#define WM_THREAD_SETCAPTURE     WM_USER + 0x104
#define WM_THREAD_SETCURSOR      WM_USER + 0x105
#define WM_THREAD_BEEP           WM_USER + 0x106

#define hasEventQueued() (eventQueueHead != NULL)
#define EVENT_THREAD_STACKSIZE  (4096*6)

typedef int (*intf)(int);

/*
 * keep the windows cursor and others local in the HWND struct.
 */
#define LI_TOPWIN       0x0001
#define LI_INPUTWIN     0x0002
#define LI_NATIVEWIN    0x0004

typedef struct {
        HCURSOR         hCursor;
        HBRUSH          viewBgBrush;  /* if that is nil, it has a solid bg color */
        COLORREF        viewBgColor;
        int             eventMask;
        short           flag;         /* LI_ - flags bits */
        short           minWidth;
        short           maxWidth;
        short           minHeight;
        short           maxHeight;
        short           bw;
        unsigned char   iconified;
        unsigned char   viewGravity;
        unsigned char   unmapping;
#if 0
        short           bgOffsX;      /* bg-pattern offset */
        short           bgOffsY;      /* bg-pattern offset */
#endif
        short           mouseX;       /* last mouseX */
        short           mouseY;       /* last mouseY */
        COLORREF        bdColor;
} localWindowInfo;
typedef localWindowInfo *plocalWindowInfo;

typedef struct createWindowInfo {
        localWindowInfo *localWindowInfo;  /* in param */
        HANDLE          newWinHandle;      /* out param */
        char            *windowName;       /* in params */
        char            *className;
        int             winStyleBits;
        int             winStyleBitsEx;
        HANDLE          parentHandle;
        int             x;
        int             y;
        int             dx;
        int             dy;
        HANDLE          hCreateEvent;
        short           infoWasRead;
        unsigned short  sequenceNr;
        unsigned        errCode;
} createWindowInfo;

#define INVALIDATED_CWI 0xFFFF             /* seqNr for invalidated CWI */

static createWindowInfo *pendingCREATEWINDOWInfo = 0;
static unsigned short pendingSequenceNr = INVALIDATED_CWI;

#ifdef OLD
# define GWL_LOCALINFO  0
#else
# define GWL_LOCALINFO  GWL_USERDATA
#endif

#define N_WINDOW_PRIVATE (sizeof(plocalWindowInfo))

#define GETLOCALWINDOWINFOPTR(__hWnd__) \
        ((localWindowInfo *)GetWindowLong(__hWnd__, GWL_LOCALINFO))

#define SETLOCALWINDOWINFOPTR(__hWnd__,__ptr__) \
        SetWindowLong(__hWnd__, GWL_LOCALINFO , (DWORD)__ptr__)

#define SetWindow_Cursor(__hWnd__, __hCurs__) \
        (GETLOCALWINDOWINFOPTR(__hWnd__) ? (GETLOCALWINDOWINFOPTR(__hWnd__)->hCursor = __hCurs__) : 0)

#define GetWindow_Cursor(__hWnd__) \
        (GETLOCALWINDOWINFOPTR(__hWnd__) ? GETLOCALWINDOWINFOPTR(__hWnd__)->hCursor : 0)

#define SetWindow_viewBgColor(__hWnd__, __viewBgColor__) \
        (GETLOCALWINDOWINFOPTR(__hWnd__) ? (GETLOCALWINDOWINFOPTR(__hWnd__)->viewBgColor = __viewBgColor__) : 0)

#define GetWindow_viewBgColor(__hWnd__) \
        (GETLOCALWINDOWINFOPTR(__hWnd__) ? GETLOCALWINDOWINFOPTR(__hWnd__)->viewBgColor : 0)

#define SetWindow_bdColor(__hWnd__, __bdColor__) \
        (GETLOCALWINDOWINFOPTR(__hWnd__) ? (GETLOCALWINDOWINFOPTR(__hWnd__)->bdColor = __bdColor__) : 0)

#define GetWindow_bdColor(__hWnd__) \
        (GETLOCALWINDOWINFOPTR(__hWnd__) ? GETLOCALWINDOWINFOPTR(__hWnd__)->bdColor : 0)

#define SetWindow_iconified(__hWnd__, __iconified__) \
        (GETLOCALWINDOWINFOPTR(__hWnd__) ? (GETLOCALWINDOWINFOPTR(__hWnd__)->iconified = __iconified__) : 0)

#define GetWindow_iconified(__hWnd__) \
        (GETLOCALWINDOWINFOPTR(__hWnd__) ? GETLOCALWINDOWINFOPTR(__hWnd__)->iconified : 0)

#define SetWindow_unmapping(__hWnd__, __unmapping__) \
        (GETLOCALWINDOWINFOPTR(__hWnd__) ? (GETLOCALWINDOWINFOPTR(__hWnd__)->unmapping = __unmapping__) : 0)

#define GetWindow_unmapping(__hWnd__) \
        (GETLOCALWINDOWINFOPTR(__hWnd__) ? GETLOCALWINDOWINFOPTR(__hWnd__)->unmapping : 0)

#define SetWindow_mouseX(__hWnd__, __mouseX__) \
        (GETLOCALWINDOWINFOPTR(__hWnd__) ? (GETLOCALWINDOWINFOPTR(__hWnd__)->mouseX = __mouseX__) : 0)

#define GetWindow_mouseX(__hWnd__) \
        (GETLOCALWINDOWINFOPTR(__hWnd__) ? GETLOCALWINDOWINFOPTR(__hWnd__)->mouseX : 0)

#define SetWindow_mouseY(__hWnd__, __mouseY__) \
        (GETLOCALWINDOWINFOPTR(__hWnd__) ? (GETLOCALWINDOWINFOPTR(__hWnd__)->mouseY = __mouseY__) : 0)

#define GetWindow_mouseY(__hWnd__) \
        (GETLOCALWINDOWINFOPTR(__hWnd__) ? GETLOCALWINDOWINFOPTR(__hWnd__)->mouseY : 0)

#define SetWindow_mouseXY(__hWnd__, __mouseX__, __mouseY__) \
        { SetWindow_mouseX(__hWnd__, __mouseX__); SetWindow_mouseY(__hWnd__, __mouseY__); }

#define SetWindow_viewBgBrush(__hWnd__, __viewBgBrush__) \
        (GETLOCALWINDOWINFOPTR(__hWnd__) ? (GETLOCALWINDOWINFOPTR(__hWnd__)->viewBgBrush = __viewBgBrush__) : 0)

#define GetWindow_viewBgBrush(__hWnd__) \
        (GETLOCALWINDOWINFOPTR(__hWnd__) ? GETLOCALWINDOWINFOPTR(__hWnd__)->viewBgBrush : 0)

#define SetWindow_bw(__hWnd__, __bw__) \
        (GETLOCALWINDOWINFOPTR(__hWnd__) ? (GETLOCALWINDOWINFOPTR(__hWnd__)->bw = __bw__) : 0)

#define GetWindow_bw(__hWnd__) \
        (GETLOCALWINDOWINFOPTR(__hWnd__) ? GETLOCALWINDOWINFOPTR(__hWnd__)->bw : 0)

#define GetWindow_paintInfoPtr(__hWnd__) \
        (GETLOCALWINDOWINFOPTR(__hWnd__) ? &(GETLOCALWINDOWINFOPTR(__hWnd__)->paintInfo) : 0)

#define GetWindow_sizeInfoPtr(__hWnd__) \
        (GETLOCALWINDOWINFOPTR(__hWnd__) ? &(GETLOCALWINDOWINFOPTR(__hWnd__)->sizeInfo) : 0)

#define SetWindow_flag(__hWnd__, __flag__) \
        (GETLOCALWINDOWINFOPTR(__hWnd__) ? (GETLOCALWINDOWINFOPTR(__hWnd__)->flag = __flag__) : 0)

#define GetWindow_flag(__hWnd__) \
        (GETLOCALWINDOWINFOPTR(__hWnd__) ? GETLOCALWINDOWINFOPTR(__hWnd__)->flag : 0)

#define GetWindow_eventMask(__hWnd__) \
        (GETLOCALWINDOWINFOPTR(__hWnd__) ? (GETLOCALWINDOWINFOPTR(__hWnd__)->eventMask) : 0)

struct queuedEvent {
        struct queuedEvent     *ev_next;
        int                     count;
        int                     ev_flag;
        HWND                    ev_hWnd;
        UINT                    ev_message;
        UINT                    ev_wParam;
        int                     ev_arg1;
        int                     ev_arg2;
        int                     ev_arg3;
        int                     ev_arg4;
        UINT                    ev_time;
};

#define ev_x    ev_arg1
#define ev_y    ev_arg2
#define ev_w    ev_arg3
#define ev_h    ev_arg4

#define ev_keyCode   ev_wParam
#define ev_scanCode  ev_arg3
#define ev_modifiers ev_arg4

#define EV_CHUNK_CNT    10000
#define xxEV_CHUNK_CNT    1000
#define EV_CHUNK_SZ     (EV_CHUNK_CNT*sizeof(struct queuedEvent))

#define BITBLT_COPY             SRCCOPY
#define BITBLT_COPYINVERTED     NOTSRCCOPY
#define BITBLT_XOR              SRCINVERT
#define BITBLT_AND              SRCAND
#define BITBLT_OR               SRCPAINT

%}
! !


!WinPrinter class methodsFor:'instance creation'!

new
    ^ self basicNew initialize.

    "Created: / 28-07-2006 / 19:52:01 / fm"
!

on: aPrinterInfo 
|newWinPrinter|
newWinPrinter := self new.
newWinPrinter printerInfo: aPrinterInfo.
^ newWinPrinter

    "Created: / 04-08-2006 / 12:57:06 / fm"
! !

!WinPrinter methodsFor:'accessing'!

getLogicalPixelSizeX
    ^ printerInfo printQuality ? 600

    "Created: / 04-08-2006 / 12:49:40 / fm"
!

getLogicalPixelSizeY
    ^ printerInfo printQuality ? 600

    "Created: / 04-08-2006 / 12:49:29 / fm"
!

height
    ^ height

    "Created: / 28-07-2006 / 18:13:12 / fm"
!

height:something
    height := something.

    "Created: / 28-07-2006 / 18:13:12 / fm"
!

printerInfo: aPrinterInfo
    printerInfo :=aPrinterInfo

    "Created: / 04-08-2006 / 12:54:09 / fm"
!

width
    ^ width

    "Created: / 28-07-2006 / 18:13:06 / fm"
!

width:something
    width := something.

    "Created: / 28-07-2006 / 18:13:06 / fm"
! !

!WinPrinter methodsFor:'drawing'!

displayArcX:x y:y width:width height:height from:startAngle angle:angle in:ignoredDrawableId with:aDC
    "draw an arc. If any of x,y, w or h is not an integer, an error is triggered.
     The angles may be floats or integer - they are given in degrees."

%{
    int __x, __y, w, h;
    float angle1, angle2;
    double f;

    if (__isSmallInteger(startAngle))
        angle1 = (float)(__intVal(startAngle));
    else if (__isFloat(startAngle)) {
        angle1 = (float) __floatVal(startAngle);
    } else if (__isShortFloat(startAngle)) {
        angle1 = __shortFloatVal(startAngle);
    } else goto bad;

    if (__isSmallInteger(angle))
        angle2 = (float)(__intVal(angle));
    else if (__isFloat(angle)) {
        angle2 = (float) __floatVal(angle);
    } else if (__isShortFloat(angle)) {
        angle2 = __shortFloatVal(angle);
    } else goto bad;

    if (angle2 <= 0) {
        RETURN (self);
    }

    if (__isExternalAddressLike(aDC)
     && __bothSmallInteger(x, y)
     && __bothSmallInteger(width, height))
     {
        POINT p;
        HANDLE hDC = (HANDLE)(__externalAddressVal(aDC));
        DWORD clr = 0 /* 0xFFFFFFFF */;    
        HANDLE prevPen, hPen = CreatePen(PS_SOLID, 1, clr);
        double xB, yB, xE, yE, xR, yR;

        w = __intVal(width);
        h = __intVal(height);
        __x = __intVal(x);
        __y = __intVal(y);

            xR = w / 2;
            yR = h / 2;
            if (angle2 - angle1 >= 360) {
                xB = xE = __x + xR + 0.5;
                yB = yE = __y /*+ yR + 0.5*/;
            } else {
                double sin(), cos();
                float rad1, rad2;

                if (angle1 <= 180)
                  angle1 = 180 - angle1;
                else
                  angle1 = 360 + 180 - angle1;
                angle2 = angle1 - angle2;
                /* sigh - compute the intersections ... */
                rad1 = (angle1 * 3.14159265359) / 180.0;
                rad2 = (angle2 * 3.14159265359) / 180.0;
                xB = cos(rad1) * xR;
                yB = sin(rad1) * yR;
                xE = cos(rad2) * xR;
                yE = sin(rad2) * yR;
                xB = __x + xR - xB + 0.5;
                yB = __y + yR - yB + 0.5;
                xE = __x + xR - xE + 0.5;
                yE = __y + yR - yE + 0.5;
            }
            prevPen = SelectObject(hDC, hPen);
            DPRINTF(("Arc x=%d y=%d w=%d h=%d xB=%d xE=%d yB=%d yE=%d a1=%f a2=%f\n",__x,__y,w,h,(int)xB,(int)xE,(int)yB,(int)yE,angle1,angle2));
            Arc(hDC,
                __x, __y,
                __x + w, __y + h,
                (int)xB, (int)yB,
                (int)xE, (int)yE);

            SelectObject(hDC, prevPen);

        RETURN ( self );
    }
    bad: ;
%}.
    self primitiveFailed

    "Created: / 07-08-2006 / 10:40:27 / fm"
    "Modified: / 07-08-2006 / 14:44:21 / fm"
!

displayPolygon:aPolygon in:aDrawableId with:aDC
    "draw a polygon, the argument aPolygon is a Collection of individual points,
     which define the polygon.
     If any coordinate is not integer, an error is triggered."

    |numberOfPoints|

    numberOfPoints := aPolygon size.

%{
    OBJ point, px, py;
    int i, num;

    if (__isExternalAddressLike(aDC)
     /* && __isExternalAddress(aDrawableId) */
     && __isSmallInteger(numberOfPoints)) {
        HANDLE hDC = (HANDLE)(__externalAddressVal(aDC));
        POINT p;
        DWORD clr = 0 /* 0xFFFFFFFF */;
        HANDLE prevPen, hPen;

        num = __intVal(numberOfPoints);

        for (i=0; i<num; i++) {
            point = __AT_(aPolygon, __MKSMALLINT(i+1));
            if (! __isPoint(point)) goto fail;
            px = _point_X(point);
            py = _point_Y(point);
            if (! __bothSmallInteger(px, py)) {
                goto fail;
            }
        }

        hPen = CreatePen(PS_SOLID, 1, clr);
        prevPen = SelectObject(hDC, hPen);

        for (i=0; i<num; i++) {
            point = __AT_(aPolygon, __MKSMALLINT(i+1));
            px = _point_X(point);
            py = _point_Y(point);
            p.x = __intVal(px);
            p.y = __intVal(py);
            if (i == 0) {
                MoveToEx(hDC, p.x, p.y, NULL);
            } else {
                if (i == (num-1)) {
                    PolylineTo(hDC, &p, 1);
                } else {
                    LineTo(hDC, p.x, p.y);
#ifdef PRE_04_JUN_04
                    /*
                     * end-point ...
                     */
                    LineTo(hDC, p.x+1, p.y);
#endif
                }
            }
        }
        SelectObject(hDC, prevPen);

        RETURN ( self );
    }
fail: ;
%}

    "Created: / 07-08-2006 / 14:46:55 / fm"
!

displayRectangleX:x y:y width:width height:height in:ignoredDrawableId with:aDC
    "draw a rectangle. If the coordinates are not integers, an error is triggered."

%{ 
    int w, h;
    int xL, yT;
    if (__isExternalAddressLike(aDC)
     && __bothSmallInteger(x, y)
     && __bothSmallInteger(width, height)) {
        HANDLE hDC = (HANDLE)(__externalAddressVal(aDC));

        xL = __intVal(x);
        yT = __intVal(y);
        w = __intVal(width);
        h = __intVal(height);

        DPRINTF(("displayRectangle: %d/%d -> %d/%d\n",
                        xL, yT, w, h));

        if ((w >= 0) && (h >= 0)) {
            DWORD clr = 0 /* 0xFFFFFFFF */;
            HANDLE prevPen, hPen = CreatePen(PS_SOLID, 1, clr);

            prevPen = SelectObject(hDC, hPen);
            MoveToEx(hDC, xL, yT, NULL);
            LineTo(hDC, xL+w, yT);       // to top-right
            LineTo(hDC, xL+w, yT+h);     // to bot-right
            MoveToEx(hDC, xL, yT, NULL); // back to top-left
            LineTo(hDC, xL, yT+h);       // to bot-left
            LineTo(hDC, xL+w+1, yT+h);   // move pen one pixel more

            SelectObject(hDC, prevPen);
        }
        RETURN ( self );
    }
%}.
    self primitiveFailed

    "Created: / 28-07-2006 / 20:18:25 / fm"
!

displayString:aString from:index1 to:index2 x:x y:y in:ignoredDrawableId with:aDC opaque:opaque fontAscent:fontAscent
    "draw a sub-string - if opaque is false, draw foreground only; otherwise, draw both
     foreground and background characters.
     If the coordinates are not integers, an error is triggered."

%{  /* NOCONTEXT */
    unsigned char *cp;
    OBJ cls;
    int  i1, i2, l, n;
    int nInstBytes;

    if (__isExternalAddressLike(aDC)
     && __isNonNilObject(aString)
     && __bothSmallInteger(index1, index2)
     && __bothSmallInteger(x, y))
    {
        HANDLE hDC = (HANDLE)(__externalAddressVal(aDC));
        int pX, pY;
        pX = __intVal(x);
        pY = __intVal(y);
        pY -= __intVal(fontAscent);

        if (opaque == true) {
            SetBkMode(hDC, OPAQUE);
        } else {
            SetBkMode(hDC, TRANSPARENT);
        }
        SetTextColor(hDC, 0);
        SetBkColor(hDC, 0xFFFFFFFF);

        cls = __qClass(aString);

        i1 = __intVal(index1) - 1;
        if (i1 >= 0) {
            i2 = __intVal(index2) - 1;
            if (i2 < i1) {
                goto ret;
            }

            cp = _stringVal(aString);
            l = i2 - i1 + 1;

            if ((cls == @global(String)) || (cls == @global(Symbol))) {
                n = _stringSize(aString);
                if (i2 < n) {
                    cp += i1;
                    CPRINTF(("string1: %s pos=%d/%d l=%d hDC=%x hWnd=%x\n", cp, pX, pY,l,hDC,_HWNDVal(aDrawableId)));

                    if (l > 32767) {
                        l = 32767;
                    }
                    if (! TextOut(hDC, pX, pY, (char *)cp, l)) {
                        PRINTF(("Textout failed. %d\n", GetLastError()));
                    }
                    goto ret;
                }
            }

            nInstBytes = __OBJS2BYTES__(__intVal(__ClassInstPtr(cls)->c_ninstvars));
            cp += nInstBytes;
            n = __byteArraySize(aString) - nInstBytes;

            if (__isBytes(aString)) {
                if (i2 < n) {
                    cp += i1;
                    CPRINTF(("string: %s pos=%d/%d\n", cp, pX, pY));
                    if (l > 32767) {
                        l = 32767;
                    }
                    if (! TextOut(hDC, pX, pY, (char *)cp, l)) {
                        PRINTF(("Textout failed. %d\n", GetLastError()));
                    }
                    goto ret;
                }
            }

            /* Unicode */
            if (__isWords(aString)) {
                n = n / 2;
                if (i2 < n) {
                    WIDECHAR *w_cp = (WIDECHAR *)cp;

                    w_cp += i1;

                    if (! TextOutW(hDC, pX, pY, w_cp, l)) {
                        PRINTF(("TextoutW failed. %d\n", GetLastError()));
                    }
                    goto ret;
                }
            }
        }
ret:
        RETURN ( self );
    }
%}.
    self primitiveFailed

    "Created: / 28-07-2006 / 20:35:19 / fm"
! !

!WinPrinter methodsFor:'graphic context stuff'!

setFont:aFontId in:aDC
    "set font to be drawn in"

%{  /* NOCONTEXT */

    if (__isExternalAddressLike(aDC)
     && __isExternalAddress(aFontId))
    {
        HANDLE hDC = (HANDLE)(__externalAddressVal(aDC));
        HGDIOBJ prevFont, hFont;

        hFont = _HGDIOBJVal(aFontId);
        prevFont = SelectObject(hDC, hFont);

        RETURN ( self );
    }
%}.
    self primitiveFailed

    "Created: / 04-08-2006 / 12:32:53 / fm"
! !

!WinPrinter methodsFor:'initialization'!

initialize
    self initializeDeviceResourceTables

    "Modified: / 28-07-2006 / 19:52:07 / fm"
! !

!WinPrinter class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/libview/Attic/WinPrinter.st,v 1.2 2006-08-07 13:27:11 fm Exp $'
! !
